***********************************************************************
***  Tato procedura sluzi k najdeniu inverznej matice 3 na 3 k      ***
*** vstupujucej matici A(3 na 3) , ak ona existuje.                 ***
***   Vstup: A....matica 3 na 3                                     ***
***   Vystup: X....inverzna matica k matici A, ak IS=0              ***
***           IS...parameter o tom, ci inverz.matica existuje(0/1)  ***
***********************************************************************

	SUBROUTINE InvMat3(A,X,IS)

	REAL*8 A(3,3) , X(3,3) , D0 

	INTEGER*1 IS 

	Call DetMat3(A,D0)

	    IS = 0

	write(*,*) "=========DetMat3=",D0

	IF (D0 .eq. 0) THEN
	    IS = 1
	    RETURN
	ENDIF
C ------------------------------------------------------

	X(1,1)=((A(2,2)*A(3,3))-(A(3,2)*A(2,3)))/D0

	X(2,1)=-((A(2,1)*A(3,3))-(A(3,1)*A(2,3)))/D0

	X(3,1)=((A(2,1)*A(3,2))-(A(3,1)*A(2,2)))/D0

C -------------------------------------------------------

	X(1,2)=-((A(1,2)*A(3,3))-(A(3,2)*A(1,3)))/D0

	X(2,2)=((A(1,1)*A(3,3))-(A(3,1)*A(1,3)))/D0

	X(3,2)=-((A(1,1)*A(3,2))-(A(3,1)*A(1,2)))/D0

C --------------------------------------------------------

	X(1,3)=((A(1,2)*A(2,3))-(A(2,2)*A(1,3)))/D0

	X(2,3)=-((A(1,1)*A(2,3))-(A(2,1)*A(1,3)))/D0

	X(3,3)=((A(1,1)*A(2,2))-(A(2,1)*A(1,2)))/D0

C --------------------------------------------------------
	Return
	End

C =====================================================================
C == Napisal Miro Ilias dna 5.8.1997 na oslavu Pana a Spasitela J.K. ==
C =====================================================================



	           

	


